package io.tswf.groovy.bettergroovy.exception

import groovy.transform.CompileStatic

@CompileStatic
class FileTreeCreationException extends RuntimeException {
    Object source

    FileTreeCreationException(Object source) {
        super(getExceptionMessage(source))
        this.source = source
    }

    FileTreeCreationException(String message, Object source) {
        super(getExceptionMessage(source, message))
        this.source = source
    }

    FileTreeCreationException(String message, Throwable cause, Object source) {
        super(getExceptionMessage(source, message), cause)
        this.source = source
    }

    FileTreeCreationException(Throwable cause, Object source) {
        super(getExceptionMessage(source), cause)
        this.source = source
    }

    static String getExceptionMessage(Object source, String message = "") {
        return "Exception occurred while trying to create file tree for source '${source}': ${message}"
    }

    static interface Bypass {

    }
}
