package io.tswf.groovy.bettergroovy.exception

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.io.tree.IFileTreeProvider

@CompileStatic
class FileTreeProviderException extends RuntimeException implements FileTreeCreationException.Bypass {
    Object sourceObject
    IFileTreeProvider fileTreeProvider

    FileTreeProviderException(Object sourceObject, IFileTreeProvider fileTreeProvider) {
        super(getExceptionMessage(sourceObject, fileTreeProvider))
        this.sourceObject = sourceObject
        this.fileTreeProvider = fileTreeProvider
    }

    FileTreeProviderException(String message, Object sourceObject, IFileTreeProvider fileTreeProvider) {
        super(getExceptionMessage(sourceObject, fileTreeProvider, message))
        this.sourceObject = sourceObject
        this.fileTreeProvider = fileTreeProvider
    }

    FileTreeProviderException(String message, Throwable cause, Object sourceObject, IFileTreeProvider fileTreeProvider) {
        super(getExceptionMessage(sourceObject, fileTreeProvider, message), cause)
        this.sourceObject = sourceObject
        this.fileTreeProvider = fileTreeProvider
    }

    FileTreeProviderException(Throwable cause, Object sourceObject, IFileTreeProvider fileTreeProvider) {
        super(getExceptionMessage(sourceObject, fileTreeProvider), cause)
        this.sourceObject = sourceObject
        this.fileTreeProvider = fileTreeProvider
    }

    static String getExceptionMessage(Object sourceObject, IFileTreeProvider fileTreeProvider, String message = "") {
        return "Exception occurred while trying to load file tree from source '${sourceObject}' by provider '${fileTreeProvider}': ${message}"
    }
}
