package io.tswf.groovy.bettergroovy.exception

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.io.tree.IFileTreeProvider

@CompileStatic
class InvalidFileTreeSourceException extends RuntimeException {
    IFileTreeProvider fileTreeProvider
    Object sourceObject

    InvalidFileTreeSourceException(IFileTreeProvider fileTreeProvider, Object sourceObject) {
        super("The source object '${sourceObject}' is not compatible with file tree provider '${fileTreeProvider}'")
        this.fileTreeProvider = fileTreeProvider
        this.sourceObject = sourceObject
    }
}
