package io.tswf.groovy.bettergroovy.scan

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor

import java.util.zip.ZipFile
import java.util.zip.ZipInputStream

@AutoService(IResourcesProvider)
@CompileStatic
@CheckedMapConstructor
class ZipResourceProvider extends AbstractZipFileProvider {

    @Override
    ZipInputStream getZipFileInputStream(Object source) {
        if (source instanceof File) {
            return new ZipInputStream(source.newInputStream())
        }

        if (source instanceof URL) {
            if (source.protocol == "jar") {
                return new ZipInputStream(source.openStream())
            }
        }

        return null
    }

    @Override
    ZipFile getZipFile(Object source) {
        if (source instanceof File) {
            return new ZipFile(source)
        }
//
//        if (source instanceof URL) {
//            if (source.protocol == "jar" && source.toString().count("!/") == 1) {
//                return ((JarURLConnection) source.openConnection()).jarFile
//            }
//        }

        return null
    }
}

